if(CMAKE_TI_XDC_TOOLS)
  return()
endif()
set(CMAKE_TI_XDC_TOOLS 1)

set(TI_ROOT $ENV{TI_ROOT} CACHE PATH "" FORCE)
set(TI_XDC_ROOT $ENV{TI_XDC_ROOT} CACHE PATH "" FORCE)
set(TI_XDAIS_ROOT $ENV{TI_XDAIS_ROOT} CACHE PATH "" FORCE)
set(TI_BIOS_ROOT $ENV{TI_BIOS_ROOT} CACHE PATH "" FORCE)
set(TI_IPC_ROOT $ENV{TI_IPC_ROOT} CACHE PATH "" FORCE)
set(TI_EDMA3_LLD_ROOT $ENV{TI_EDMA3_LLD_ROOT} CACHE PATH "" FORCE)
set(TI_NDK_ROOT $ENV{TI_NDK_ROOT} CACHE PATH "" FORCE)
set(TI_UIA_ROOT $ENV{TI_UIA_ROOT} CACHE PATH "" FORCE)
set(TI_PDK_OMAPL138_ROOT $ENV{TI_PDK_OMAPL138_ROOT} CACHE PATH "" FORCE)
set(TI_DSPLIB_C674x_ROOT $ENV{TI_DSPLIB_C674x_ROOT} CACHE PATH "" FORCE)
set(TI_MATHLIB_C674x_ROOT $ENV{TI_MATHLIB_C674x_ROOT} CACHE PATH "" FORCE)
set(TI_XDCTOOLS_JAVA_HOME $ENV{TI_XDCTOOLS_JAVA_HOME} CACHE PATH "" FORCE)

message(STATUS "TI_ROOT: '${TI_ROOT}'")
message(STATUS "TI_CGT_C6x_ROOT: '${TI_CGT_C6x_ROOT}'")
message(STATUS "TI_XDC_ROOT: '${TI_XDC_ROOT}'")
message(STATUS "TI_XDC_BUILD_TYPE: '${TI_XDC_BUILD_TYPE}'")

set(CMAKE_TI_XDC_XS ${TI_XDC_ROOT}/xs)

function(ti_target_xdc_configuration TARGET)

  set(xs_packages )
  set(xs_target )
  set(xs_platform )
  set(xs_bld_file )
  set(xs_cgt_root )
  set(xs_cfg_file )
  set(xs_out_dir "${CMAKE_CURRENT_BINARY_DIR}/${TARGET}.xdc/ConfigPkg")
  set(xs_depends )

  set(trgt_includes "${TI_XDC_ROOT}/packages")

  set(cur_mode "no")
  set(list_var "${ARGN}")
  foreach(loop_var IN LISTS list_var)
    if ( "${loop_var}" STREQUAL "PACKAGE" )
      set(cur_mode "${loop_var}")
      set(trgt_includes ${trgt_includes} ${loop_var})
    elseif ( "${loop_var}" STREQUAL "TI-TARGET" )
      set(cur_mode "${loop_var}")
    elseif ( "${loop_var}" STREQUAL "PLATFORM" )
      set(cur_mode "${loop_var}")
    elseif ( "${loop_var}" STREQUAL "BLD_FILE" )
      set(cur_mode "${loop_var}")
    elseif ( "${loop_var}" STREQUAL "CGT_ROOT" )
      set(cur_mode "${loop_var}")
    elseif ( "${loop_var}" STREQUAL "CFG_FILE" )
      set(cur_mode "${loop_var}")
    elseif ( "${loop_var}" STREQUAL "OUT_DIR" )
      set(cur_mode "${loop_var}")
    elseif ( "${loop_var}" STREQUAL "DEPENDS" )
      set(cur_mode "${loop_var}")
    else()
      if ( ${cur_mode} STREQUAL "PACKAGE" )
        set(xs_packages "${xs_packages}${loop_var};")
      elseif ( ${cur_mode} STREQUAL "TI-TARGET" )
        set(xs_target "-t\"${loop_var}\"")
      elseif ( "${cur_mode}" STREQUAL "PLATFORM" )
        set(xs_platform "-p\"${loop_var}\"")
      elseif ( "${cur_mode}" STREQUAL "BLD_FILE" )
        set(xs_bld_file "-b\"${loop_var}\"")
      elseif ( "${cur_mode}" STREQUAL "CGT_ROOT" )
        set(xs_cgt_root "-c\"${loop_var}\"")
      elseif ( "${cur_mode}" STREQUAL "CFG_FILE" )
        set(xs_cfg_file "\"${loop_var}\"")
      elseif ( "${cur_mode}" STREQUAL "OUT_DIR" )
        set(xs_out_dir ${loop_var})
      elseif ( ${cur_mode} STREQUAL "DEPENDS" )
        set(xs_depends ${xs_depends} ${loop_var})
      endif()
    endif()
  endforeach()

  set(xs_build "-r\"${TI_XDC_BUILD_TYPE}\"")
  set(xs_configuro_out_dir "xdc.tools.configuro" "-o\"${xs_out_dir}\"")
  add_custom_target(TI_XDC_${TARGET}
      ${CMAKE_COMMAND} -E env XDCTOOLS_JAVA_HOME=${TI_XDCTOOLS_JAVA_HOME} ${CMAKE_TI_XDC_XS} "--xdcpath=\"${xs_packages}\"" ${xs_configuro_out_dir} ${xs_target} ${xs_platform} ${xs_build} ${xs_bld_file} ${xs_cgt_root} ${xs_cfg_file}
    DEPENDS
      ${xs_depends}
  )
  add_dependencies(${TARGET} TI_XDC_${TARGET})
  target_compile_options(${TARGET} PUBLIC "--cmd_file=${xs_out_dir}/compiler.opt")
  target_link_libraries(${TARGET} PUBLIC "${xs_out_dir}/linker.cmd")

endfunction()
